
function  xfit = STFfittingAnalytical(Y2x,Model,Parameter)
% linear measurement model -fitting; the sensor data is converted into the
% state (position) space and then carry out fitting Analytical
% However, the analytical solution performs disappointingly compared to the numerial
% approximation such as the tool polyfit provided in Matlab.

St =1;
xfit(:,1) = Y2x([1,2],1);
% xfit(:,2) = Y2x([1,2],2);
xfit(:,2) =Y2x([1,2],2)*2-Y2x([1,2],1); % Y2x([1,2],2)*2-Y2x([1,2],1);

for i = 3:size(Y2x,2)
    if i <= Parameter.Band
        flag =ceil(i/2);
    end
    if i-St >= Parameter.Band
        St = i - Parameter.Band;
        flag = i- floor(Parameter.Band/2);
    end
        xout = Y2x([1,2],St:i);
        T = St:i;
%         [p1]= polyfit(T, xout(1,:), Parameter.FitOrder);
%         [p2]= polyfit(T, xout(2,:), Parameter.FitOrder);  
%     switch Model 
%         case 'smoothing'
%             [xfit(1,flag:i)] = polyval(p1,flag:i);
%             [xfit(2,flag:i)] = polyval(p2,flag:i); 
%         case 'filtering'
%             [xfit(1,i)] = polyval(p1,i);
%             [xfit(2,i)] = polyval(p2,i);
%         case 'forecasting'
% %             Parameter.Band = 50;
%             [xfit(1,i+Parameter.predictStep)] = polyval(p1,i+Parameter.predictStep);
%             [xfit(2,i+Parameter.predictStep)] = polyval(p2,i+Parameter.predictStep);
%         otherwise
%             disp('Please choose a correct fitting model from smoothing, filtering and forecasting')
%     end

        a2 = (sum(T)*sum(xout(1,:))/abs(St-i) - xout(1,:)*T')/(sum(T)^2/abs(St-i)-T*T');
        a1 = (sum(xout(1,:))-sum(T)*a2)/abs(St-i);

        b2 = (sum(T)*sum(xout(2,:))/abs(St-i) - xout(2,:)*T')/(sum(T)^2/abs(St-i)-T*T');
        b1 = (sum(xout(2,:))-sum(T)*b2)/abs(St-i);
%         syms x
%         Yeqn =  sum(xout(2,:).*T) - sum((sum(xout(2,:))-sum(T)*x).*T)/(St-i)-x*sum(T.^2)==0;
%         b22 = solve(Yeqn, x);b11 = (sum(xout(2,:))-sum(T)*b22)/(St-i); 
%         [p2]= polyfit(T, xout(2,:), Parameter.FitOrder);  
    switch Model 
        case 'smoothing'
            [xfit(1,flag:i)] = a1+ a2*[flag:i];
            [xfit(2,flag:i)] = b1+ b2*[flag:i]; 
        case 'filtering'
            [xfit(1,i)] = a1+a2*i;
            [xfit(2,i)] = b1+b2*i;
        case 'forecasting'
%             Parameter.Band = 50;
            [xfit(1,i+Parameter.predictStep)] = a1+a2*(i+Parameter.predictStep);
            [xfit(2,i+Parameter.predictStep)] = b1+b2*(i+Parameter.predictStep);
        otherwise
            disp('Please choose a correct fitting model from smoothing, filtering and forecasting')
    end        
        
end
