
function  xfit = nlinSTFfitting_cML(Y,s,Parameter)

p0 = [-0.1,0.1]; % m=2, two dimensions
% p = [0.01, 0.1, 0.5,  0.01,0.1, 0.15]; % m=3, two dimensions

St =1; options=optimset('Display','off');
% Parameter.initial warms up the first two steps of the fitting,
xfit(:,1) = Parameter.initial([1,2],:); % for fair, we also set a good start point for fitting as did with all filters/smoother
xfit(:,2) = [Parameter.initial(1,1)+Parameter.initial(3,1);Parameter.initial(2,1)+Parameter.initial(4,1)];
for i = 3:size(Y,2)     
%     if i <= Parameter.Band
%         flag =ceil(i/2);
%     end
%     if i-St >= Parameter.Band
%         St = i - Parameter.Band;
%         flag = i- floor(Parameter.Band/2);
%     end

    if i <= 40
        H_fun = @(x,t) [atan2(-s(2,1),x(1)+x(2)*t-s(1,1));
            atan2(-s(2,2),x(1)+x(2)*t-s(1,2));
            atan2(-s(2,3),x(1)+x(2)*t-s(1,3)); 
            atan2(-s(2,4),x(1)+x(2)*t-s(1,4))]; % each row represents a bearing only sensor - 1st order
        T = St:i;        
        [p,~] = lsqcurvefit(H_fun,p0,T,Y(:,St:i),[],[],options);
        % resnorm may be used for some ad-hoc monitor and decision
Movement = polyval(p,i);
            [xfit(1,i)] = 0+Movement; % 
            [xfit(2,i)] = 0; 
    end
%     xx = cML(:,t);
    if i>40&&i<=90
%         St = 41;
        H_fun = @(x,t) [atan2(1+cos(x(1)+x(2)*t-3.9)-s(2,1),3.9+sin(x(1)+x(2)*t-3.9)-s(1,1));
            atan2(1+cos(x(1)+x(2)*t-3.9)-s(2,2),3.9+sin(x(1)+x(2)*t-3.9)-s(1,2));
            atan2(1+cos(x(1)+x(2)*t-3.9)-s(2,3),3.9+sin(x(1)+x(2)*t-3.9)-s(1,3)); 
            atan2(1+cos(x(1)+x(2)*t-3.9)-s(2,4),3.9+sin(x(1)+x(2)*t-3.9)-s(1,4));]; % each row represents a bearing only sensor - 1st order
        T = St:i;        
        [p,~] = lsqcurvefit(H_fun,p0,T,Y(:,St:i),[],[],options);
        % resnorm may be used for some ad-hoc monitor and decision
Movement = polyval(p,i);
        
            [xfit(1,i)] = 3.9+sin(Movement-3.9);%
            [xfit(2,i)] = 1+cos(Movement-3.9); 
    end 
    if i>90&& i<=110
%         St = 91;
        H_fun = @(x,t) [atan2(1-cos(5)+(x(1)+x(2)*t-8.9)*sin(5)-s(2,1),3.9+sin(5)+(x(1)+x(2)*t-8.9)*cos(5)-s(1,1));
            atan2(1-cos(5)+(x(1)+x(2)*t-8.9)*sin(5)-s(2,2),3.9+sin(5)+(x(1)+x(2)*t-8.9)*cos(5)-s(1,2));
            atan2(1-cos(5)+(x(1)+x(2)*t-8.9)*sin(5)-s(2,3),3.9+sin(5)+(x(1)+x(2)*t-8.9)*cos(5)-s(1,3)); 
            atan2(1-cos(5)+(x(1)+x(2)*t-8.9)*sin(5)-s(2,4),3.9+sin(5)+(x(1)+x(2)*t-8.9)*cos(5)-s(1,4));]; % each row represents a bearing only sensor - 1st order
        T = St:i;        
        [p,~] = lsqcurvefit(H_fun,p0,T,Y(:,St:i),[],[],options);
        % resnorm may be used for some ad-hoc monitor and decision
Movement = polyval(p,i);

            [xfit(1,i)] = 3.9+sin(5)+(Movement-8.9)*cos(5);%
            [xfit(2,i)] = 1-cos(5)+(Movement-8.9)*sin(5); %
    end 
%     xx = cML(:,t);
    if i>110 && i<=160
%         St = 111;
        H_fun = @(x,t) [atan2((1+2*sin(5)-2*cos(5))+sin(15.9-x(1)-x(2)*t)-s(2,1),(3.9+2*sin(5)+2*cos(5))+cos(15.9-x(1)-x(2)*t)-s(1,1));
            atan2((1+2*sin(5)-2*cos(5))+sin(15.9-x(1)-x(2)*t)-s(2,2),(3.9+2*sin(5)+2*cos(5))+cos(15.9-x(1)-x(2)*t)-s(1,2));
            atan2((1+2*sin(5)-2*cos(5))+sin(15.9-x(1)-x(2)*t)-s(2,3),(3.9+2*sin(5)+2*cos(5))+cos(15.9-x(1)-x(2)*t)-s(1,3)); 
            atan2((1+2*sin(5)-2*cos(5))+sin(15.9-x(1)-x(2)*t)-s(2,4),(3.9+2*sin(5)+2*cos(5))+cos(15.9-x(1)-x(2)*t)-s(1,4));]; % each row represents a bearing only sensor - 1st order
        T = St:i;        
        [p,~] = lsqcurvefit(H_fun,p0,T,Y(:,St:i),[],[],options);
        % resnorm may be used for some ad-hoc monitor and decision
Movement = polyval(p,i);

            [xfit(1,i)] = (3.9+2*sin(5)+2*cos(5))+cos(15.9-Movement);%-
            [xfit(2,i)] = (1+2*sin(5)-2*cos(5))+sin(15.9-Movement); 
    end
    if i>160 && i<=200
%         St = 161;
        H_fun = @(x,t) [atan2(2-2*cos(5)+2*sin(5)-s(2,1),(3.9+2*sin(5)+2*cos(5))+x(1)+x(2)*t-15.9-s(1,1));
            atan2(2-2*cos(5)+2*sin(5)-s(2,2),(3.9+2*sin(5)+2*cos(5))+x(1)+x(2)*t-15.9-s(1,2));
            atan2(2-2*cos(5)+2*sin(5)-s(2,3),(3.9+2*sin(5)+2*cos(5))+x(1)+x(2)*t-15.9-s(1,3)); 
            atan2(2-2*cos(5)+2*sin(5)-s(2,4),(3.9+2*sin(5)+2*cos(5))+x(1)+x(2)*t-15.9-s(1,4));]; % each row represents a bearing only sensor - 1st order
        T = St:i;        
        [p,~] = lsqcurvefit(H_fun,p0,T,Y(:,St:i),[],[],options);
        % resnorm may be used for some ad-hoc monitor and decision
Movement = polyval(p,i);

            [xfit(1,i)] = (3.9+2*sin(5)+2*cos(5))+Movement-15.9;%
            [xfit(2,i)] = 2-2*cos(5)+2*sin(5);         
    end

end
