

function [xfit, Esigma]= fitting(xout,order) 

% fitting O2_inference

if size(xout,2)<=order+1
    xfit=xout;
    Esigma= zeros(1,size(xout,2));
else
    T = 1:size(xout,2);
%                 [curve] = fit( xout(1,:)', xout(2,:)', 'smoothingspline' );
%                 plot(curve)
    [p1, S1]= polyfit(T, xout(1,:), order);
    [p2, S2]= polyfit(T, xout(2,:), order);
    [xfit(1,:),Esigma1]=polyval(p1,T,S1);
    [xfit(2,:),Esigma2]=polyval(p2,T,S2);
Esigma = (Esigma1+Esigma2)/2;

% p = polyfit(xout(1,:)', xout(2,:)', order); % no working!!
% xfit(2)=polyval(p2,size(xout,2));

end
